<template>
  <el-drawer
    v-model="showSidebar"
    :direction="sideBarDirection"
    :before-close="toggleSidebar"
    :show-close="false"
    custom-class="left-side-bar-style-3 !w-[280px]"
  >
    <template #header>
      <div class="flex w-full" :class="{ 'justify-end': isRtlDirection }">
        <button
          type="button"
          class="p-4 h-full max-w-fit"
          @click="toggleSidebar"
        >
          <IconChevronLeft
            class="w-4 h-4 icon-back"
            :class="{ 'rotate-180': isRtlDirection }"
          />
        </button>
      </div>
    </template>
    <div v-if="auth" class="bg-background5 rounded-lg">
      <NuxtLink
        v-for="(tab, index) in tabs"
        :key="index"
        :to="tab.to"
        class="px-[17px] flex flex-nowrap user-center-element items-center p-4 justify-between"
        @click="toggleSidebar"
      >
        <div class="relative flex items-center">
          <SvgIcon
            class="w-[16px] h-[16px] !fill-[var(--text5)]"
            :svg-name="tab.icon"
          />
          <div class="overflow-hidden user-center-label pl-4 text-sm fc-text4">
            {{ $t(tab.label) }}
          </div>
        </div>
        <div
          v-if="tab.label === 'messages' && isHasUnreadMessage"
          class="bg-failure w-fit h-4 fc-textBtn text-xs px-[6px] rounded-full"
        >
          {{ unreadInfo.TotalCount }}
        </div>
      </NuxtLink>
    </div>
    <div v-else class="flex gap-2">
      <button
        class="rounded-lg bg-secondary w-full h-10 fc-textBtn text-xs"
        @click="onClickLogin()"
      >
        {{ $t("capital_login") }}
      </button>
      <button
        class="rounded-lg bg-primary w-full h-10 fc-textBtn text-xs"
        @click="onClickJoinnow()"
      >
        {{ $t("joinnow") }}
      </button>
    </div>
    <div class="flex flex-col bg-background5 rounded-lg my-2 py-2">
      <template v-if="!isIndependentModule">
        <nuxt-link
          v-for="menu in menuTabHeaders"
          :key="menu.TabType"
          :to="menu.TabURL"
          :name="menu.TabType"
          class="game-type"
          @click="toggleSidebar"
        >
          <div
            class="flex items-center h-12 whitespace-nowrap gap-6 space relative pl-6"
            :class="{ 'border-selected': checkActiveTab(activetab, menu) }"
          >
            <div
              class="w-4 h-4 icon"
              :class="
                checkActiveTab(activetab, menu) ? 'opacity-100' : 'opacity-50'
              "
            >
              <svg-icon
                :svg-name="`icon-${menu?.TabType.toLowerCase().replace(
                  ' ',
                  '-'
                )}`"
                class="icon w-4 h-4"
              />
            </div>
            <p
              class="text-sm leading-[14px] uppercase --text4"
              :class="{ 'font-[700]': checkActiveTab(activetab, menu) }"
            >
              {{ $t(menu.TabType.replace(" ", "_").toLowerCase()) }}
            </p>
          </div>
        </nuxt-link>
      </template>
      <nuxt-link
        v-if="isAllowPromotionTab"
        to="/promotion"
        name="Promotion"
        class="game-type"
        @click="toggleSidebar"
      >
        <div
          class="flex items-center h-12 whitespace-nowrap gap-6 space relative pl-6"
          :class="{ 'border-selected': tabSelected === '/promotion' }"
        >
          <div
            class="w-4 h-4 icon opacity-50"
            :class="tabSelected === '/promotion' ? 'opacity-100' : 'opacity-50'"
          >
            <svg-icon
              svg-name="icon-promotion-2"
              class="icon w-4 h-4 !fill-[var(--text5)]"
            />
          </div>
          <p
            class="text-sm leading-[14px] --text4"
            :class="{ 'font-[700]': tabSelected === '/promotion' }"
          >
            {{ $t("promotion") }}
          </p>
        </div>
      </nuxt-link>
    </div>
    <div class="bg-background5 rounded-lg">
      <LanfuageStyle3 @expanded="onScrollToLastLangElement" />
    </div>
    <div
      v-if="auth"
      class="h-12 flex items-center bg-background5 rounded-lg mt-2 px-6 cursor-pointer"
      @click="logout"
    >
      <div class="flex justify-between items-center w-full">
        <div class="flex items-center">
          <SvgIcon
            class="w-4 h-4 !fill-[var(--text5)]"
            svg-name="icon-sign-out"
          />
          <div class="overflow-hidden user-center-label">
            <span class="pl-6 fc-text4">{{ $t("logout") }}</span>
          </div>
        </div>
        <div class="m-angle-right-container">
          <font-awesome-icon
            icon="angle-right"
            class="m-language-collapse h-4 fc-text4"
          />
        </div>
      </div>
    </div>
    <template v-if="isAppDownloadEnabled">
      <div class="h-16 w-full"></div>
      <a :href="appUrl" class="absolute left-0 w-full bottom-0" download>
        <div class="bg-theme-color !rounded-none relative">
          <div class="flex items-end justify-between h-16 gap-1 px-1">
            <div class="w-[68px] h-[68px] flex-shrink-0">
              <img
                :src="
                  getAssetImage('assets/theme/new_black_theme/app_download.png')
                "
                alt=""
              />
            </div>
            <div class="flex items-center p-0 gap-1 h-16 z-[1]">
              <div class="flex flex-col justify-center items-start p-0 h-16">
                <span class="app-download-title">{{ brandName }} APP</span>
                <span class="app-download-content"
                  >Download <br />
                  our Android APP</span
                >
              </div>
              <div class="h-[32px]">
                <el-button
                  type="danger"
                  round
                  class="capitalize download-button"
                  >{{ $t("download") }}</el-button
                >
              </div>
            </div>
          </div>
          <div
            class="bg-app-download !right-0 !top-0 !left-[unset] !h-16"
            :style="`background-image: ${bgApp};`"
          ></div>
        </div>
      </a>
    </template>
  </el-drawer>
</template>

<script setup lang="ts">
import LanfuageStyle3 from "@/components/m-header-style-module/language-selection-style-3.client.vue";
import { store } from "@/store";
import { useHeaderComponent } from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";
import useMenu from "@/composables/useMenu";
import IconChevronLeft from "~/assets/icons/chevron-left.svg?component";
import { TabInfo } from "~~/models/IGetPlayableGamesResponse";
import { memberMessageStore } from "~~/store/member-message";
import { useMessage } from "~~/composables/useMessage";

const showSidebar = computed(() => store.state.showSidebar);
const toggleSidebar = () => {
  store.commit("updateSidebar", !store.state.showSidebar);
};
const {
  auth,
  menuTabHeaders,
  isAllowPromotionTab,
  tabSelected,
  logout,
  isAppDownloadEnabled,
  appUrl,
} = useHeaderComponent();
const bgApp = `url(${commonHelper.getAssetImage(
  "assets/theme/new_black_theme/bg-app-download.png"
)})`;
const brandName = themePropertyHelper.getSingleThemeProperty(
  store.state.companyThemePropertiesFromApi.ThemeProperties,
  "seo_brand_name"
).Text;
const { isCashPlayer, isShowDepositWithdrawal } = useMenu();
const tabs = reactive([
  {
    to: "/deposit",
    label: "deposit",
    icon: "icon-deposit",
    display: auth ? isCashPlayer.value && isShowDepositWithdrawal.value : true,
  },
  {
    to: "/withdrawal",
    label: "withdrawal",
    icon: "icon-withdraw",
    display: auth ? isCashPlayer.value && isShowDepositWithdrawal.value : true,
  },
  { to: "/account", label: "account", icon: "icon-account-v2", display: true },
  {
    to: "/messages",
    label: "messages",
    icon: "icon-message",
    display: true,
  },
]).filter((p) => p.display);
const isHasUnreadMessage = computed(() => {
  return memberMessageStore.getters.isHasUnreadMessage;
});
const { unreadInfo } = useMessage();
const route = useRoute();
const activetab = computed(() =>
  route.path === "/" ? route.path : route.path.slice(1) || "sports"
);
const checkActiveTab = (active: string, menu: TabInfo) => {
  if (route.matched[0].name === "GameInitial") {
    return active
      .replace(" ", "")
      .replace("-", "")
      .toLowerCase()
      .includes(menu?.TabType.replace(" ", "").toLowerCase());
  }
  if (route.matched[0].name !== "GameInitial") {
    return (
      active.replace(" ", "").replace("-", "").toLowerCase() ===
      menu?.TabType.replace(" ", "").toLowerCase()
    );
  }
  return false;
};
const { toggleLoginRegisterDialog, getAssetImage } = commonHelper;
const onClickLogin = () => {
  toggleLoginRegisterDialog();
  toggleSidebar();
};

const onClickJoinnow = () => {
  toggleLoginRegisterDialog(false);
  toggleSidebar();
};
const onScrollToLastLangElement = (lastEl: HTMLElement) => {
  lastEl.scrollIntoView({
    behavior: "smooth",
    block: "start",
  });
};
const isIndependentModule = useState(KEYS.IS_INDEPENDENT_MODULE);
const sideBarDirection = computed(() => store.state.sideBarDirection);
const isRtlDirection = computed(() => {
  return sideBarDirection.value === "rtl";
});
</script>

<style lang="scss" scope>
.left-side-bar-style-3 {
  background: var(--background2);
  .el-drawer__header {
    margin-bottom: unset;
    background: var(--background3);
    height: 48px;
    padding: unset;
    .icon-back {
      path {
        fill: var(--text3);
      }
    }
  }
  .el-drawer__body {
    padding: 8px 16px;
    .border-selected:before {
      content: "";
      position: absolute;
      top: 0;
      left: 0;
      bottom: 0;
      width: 3px;
      background: var(--primary);
    }
  }
}
</style>
